## tinyssh 20250201

=== Makefile ===
CC?=cc
CFLAGS+=-W -Wall -Os -fPIC -fwrapv -Werror=deprecated-declarations -Icryptoint
LDFLAGS?=
CPPFLAGS?=

DESTDIR?=
PREFIX?=/usr/local

INSTALL?=install

LINKS=tinysshd-makekey tinysshd-printkey tinysshnoneauthd

BINARIES=tinysshd _tinysshd-printkex _tinysshd-speed _tinysshd-test-hello1 \
 _tinysshd-test-hello2 _tinysshd-test-kex1 _tinysshd-test-kex2 \
 _tinysshd-unauthenticated

TESTCRYPTOBINARIES=test-crypto

OBJLIB=blocking.o buf.o byte.o channel.o channel_drop.o channel_fork.o \
 channel_forkpty.o channel_subsystem.o cleanup.o coe.o connectioninfo.o \
 crypto_dh_x25519.o crypto_hash_sha256.o crypto_hash_sha512_lib25519.o \
 crypto_hash_sha512_tinyssh.o crypto_kem_sntrup761_libntruprime.o \
 crypto_kem_sntrup761_tinyssh.o crypto_kem_sntrup761x25519.o \
 crypto_onetimeauth_poly1305.o crypto_scalarmult_curve25519.o \
 crypto_sign_ed25519_lib25519.o crypto_sign_ed25519_tinyssh.o \
 crypto_sort_uint32.o crypto_stream_chacha20.o crypto_verify_16.o \
 crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o fe.o ge25519.o \
 getln.o global.o int16_optblocker.o int32_optblocker.o int64_optblocker.o \
 int8_optblocker.o iptostr.o load.o log.o loginshell.o logsys.o main_tinysshd.o \
 main_tinysshd_makekey.o main_tinysshd_printkey.o newenv.o numtostr.o open.o \
 packet_auth.o packet.o packet_channel_open.o packet_channel_recv.o \
 packet_channel_request.o packet_channel_send.o packet_get.o packet_hello.o \
 packet_kex.o packet_kexdh.o packetparser.o packet_put.o packet_recv.o \
 packet_send.o packet_unimplemented.o porttostr.o randommod.o readall.o \
 savesync.o sc25519.o ssh.o sshcrypto.o sshcrypto_cipher.o \
 sshcrypto_cipher_chachapoly.o sshcrypto_kex.o sshcrypto_kex_curve25519.o \
 sshcrypto_kex_sntrup761x25519.o sshcrypto_key.o sshcrypto_key_ed25519.o str.o \
 stringparser.o subprocess_auth.o subprocess_sign.o trymlock.o \
 uint16_optblocker.o uint32_optblocker.o uint64_optblocker.o uint8_optblocker.o \
 writeall.o

OBJALL=blocking.o buf.o byte.o channel.o channel_drop.o channel_fork.o \
 channel_forkpty.o channel_subsystem.o cleanup.o coe.o connectioninfo.o \
 crypto_dh_x25519.o crypto_hash_sha256.o crypto_hash_sha512_lib25519.o \
 crypto_hash_sha512_tinyssh.o crypto_kem_sntrup761_libntruprime.o \
 crypto_kem_sntrup761_tinyssh.o crypto_kem_sntrup761x25519.o \
 crypto_onetimeauth_poly1305.o crypto_scalarmult_curve25519.o \
 crypto_sign_ed25519_lib25519.o crypto_sign_ed25519_tinyssh.o \
 crypto_sort_uint32.o crypto_stream_chacha20.o crypto_verify_16.o \
 crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o fe.o ge25519.o \
 getln.o global.o int16_optblocker.o int32_optblocker.o int64_optblocker.o \
 int8_optblocker.o iptostr.o load.o log.o loginshell.o logsys.o main_tinysshd.o \
 main_tinysshd_makekey.o main_tinysshd_printkey.o newenv.o numtostr.o open.o \
 packet_auth.o packet.o packet_channel_open.o packet_channel_recv.o \
 packet_channel_request.o packet_channel_send.o packet_get.o packet_hello.o \
 packet_kex.o packet_kexdh.o packetparser.o packet_put.o packet_recv.o \
 packet_send.o packet_unimplemented.o porttostr.o randombytes.o randommod.o \
 readall.o savesync.o sc25519.o ssh.o sshcrypto.o sshcrypto_cipher.o \
 sshcrypto_cipher_chachapoly.o sshcrypto_kex.o sshcrypto_kex_curve25519.o \
 sshcrypto_kex_sntrup761x25519.o sshcrypto_key.o sshcrypto_key_ed25519.o str.o \
 stringparser.o subprocess_auth.o subprocess_sign.o test-crypto.o tinysshd.o \
 _tinysshd-printkex.o _tinysshd-speed.o _tinysshd-test-hello1.o \
 _tinysshd-test-hello2.o _tinysshd-test-kex1.o _tinysshd-test-kex2.o \
 _tinysshd-unauthenticated.o trymlock.o uint16_optblocker.o uint32_optblocker.o \
 uint64_optblocker.o uint8_optblocker.o writeall.o

AUTOHEADERS=haslib25519.h haslibntruprime.h haslibrandombytes.h haslibutilh.h \
 haslimits.h haslogintty.h hasmlock.h hasopenpty.h hasutilh.h hasutmpaddrv6.h \
 hasutmp.h hasutmphost.h hasutmploginlogout.h hasutmplogwtmp.h hasutmpname.h \
 hasutmppid.h hasutmptime.h hasutmptv.h hasutmptype.h hasutmpuser.h \
 hasutmpxaddrv6.h hasutmpx.h hasutmpxsyslen.h hasutmpxupdwtmpx.h hasvalgrind.h

TESTOUT=test-crypto-dh.out test-crypto-hash.out test-crypto-kem.out \
 test-crypto-sign.out test-crypto-sort.out test-crypto-verify.out \
 test-tinysshd-makekey.out test-tinysshd-printkey.out test-tinysshd.out \
 test-tinysshnoneauthd.out

all: $(AUTOHEADERS) $(BINARIES) $(LINKS)

blocking.o: blocking.c blocking.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c blocking.c

buf.o: buf.c byte.h str.h purge.h cleanup.h randombytes.h \
 haslibrandombytes.h cryptoint/crypto_uint32.h bug.h global.h e.h log.h \
 buf.h cryptoint/crypto_uint8.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c buf.c

byte.o: byte.c cryptoint/crypto_int16.h byte.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c byte.c

channel.o: channel.c byte.h bug.h global.h e.h log.h newenv.h purge.h \
 cleanup.h connectioninfo.h iptostr.h porttostr.h buf.h \
 cryptoint/crypto_uint8.h cryptoint/crypto_uint32.h str.h logsys.h \
 loginshell.h trymlock.h limit.h haslimits.h channel.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel.c

channel_drop.o: channel_drop.c dropuidgid.h newenv.h channel.h \
 cryptoint/crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_drop.c

channel_fork.o: channel_fork.c blocking.h open.h channel.h \
 cryptoint/crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_fork.c

channel_forkpty.o: channel_forkpty.c hasopenpty.h haslogintty.h e.h coe.h \
 blocking.h global.h channel.h cryptoint/crypto_uint32.h iptostr.h \
 porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_forkpty.c

channel_subsystem.o: channel_subsystem.c str.h log.h e.h channel.h \
 cryptoint/crypto_uint32.h iptostr.h porttostr.h limit.h haslimits.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c channel_subsystem.c

cleanup.o: cleanup.c cleanup.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c cleanup.c

coe.o: coe.c coe.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c coe.c

connectioninfo.o: connectioninfo.c e.h byte.h iptostr.h porttostr.h env.h \
 str.h connectioninfo.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c connectioninfo.c

crypto_dh_x25519.o: crypto_dh_x25519.c crypto_dh_x25519.h haslib25519.h \
 randombytes.h haslibrandombytes.h crypto_scalarmult_curve25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_dh_x25519.c

crypto_hash_sha256.o: crypto_hash_sha256.c cryptoint/crypto_uint32.h \
 cryptoint/crypto_uint64.h crypto_hash_sha256.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha256.c

crypto_hash_sha512_lib25519.o: crypto_hash_sha512_lib25519.c \
 haslib25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha512_lib25519.c

crypto_hash_sha512_tinyssh.o: crypto_hash_sha512_tinyssh.c \
 crypto_hash_sha512.h haslib25519.h cryptoint/crypto_uint64.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_hash_sha512_tinyssh.c

crypto_kem_sntrup761_libntruprime.o: crypto_kem_sntrup761_libntruprime.c \
 haslibntruprime.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761_libntruprime.c

crypto_kem_sntrup761_tinyssh.o: crypto_kem_sntrup761_tinyssh.c \
 crypto_kem_sntrup761.h haslibntruprime.h cryptoint/crypto_uint64.h \
 cryptoint/crypto_uint32.h cryptoint/crypto_uint16.h \
 cryptoint/crypto_int32.h cryptoint/crypto_int16.h \
 cryptoint/crypto_int8.h randombytes.h haslibrandombytes.h \
 crypto_verify_32.h crypto_sort_uint32.h crypto_hash_sha512.h \
 haslib25519.h crypto_declassify.h hasvalgrind.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761_tinyssh.c

crypto_kem_sntrup761x25519.o: crypto_kem_sntrup761x25519.c cleanup.h \
 crypto_hash_sha512.h haslib25519.h crypto_dh_x25519.h \
 crypto_kem_sntrup761.h haslibntruprime.h crypto_kem_sntrup761x25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761x25519.c

crypto_onetimeauth_poly1305.o: crypto_onetimeauth_poly1305.c \
 cryptoint/crypto_int16.h cryptoint/crypto_uint32.h \
 cryptoint/crypto_uint64.h crypto_onetimeauth_poly1305.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_onetimeauth_poly1305.c

crypto_scalarmult_curve25519.o: crypto_scalarmult_curve25519.c cleanup.h \
 fe25519.h fe.h cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h \
 cryptoint/crypto_uint8.h crypto_scalarmult_curve25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_scalarmult_curve25519.c

crypto_sign_ed25519_lib25519.o: crypto_sign_ed25519_lib25519.c \
 haslib25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sign_ed25519_lib25519.c

crypto_sign_ed25519_tinyssh.o: crypto_sign_ed25519_tinyssh.c \
 crypto_sign_ed25519.h haslib25519.h randombytes.h haslibrandombytes.h \
 cleanup.h crypto_hash_sha512.h crypto_verify_32.h ge25519.h fe.h \
 cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h sc25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sign_ed25519_tinyssh.c

crypto_sort_uint32.o: crypto_sort_uint32.c cryptoint/crypto_uint32.h \
 crypto_sort_uint32.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_sort_uint32.c

crypto_stream_chacha20.o: crypto_stream_chacha20.c \
 crypto_stream_chacha20.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_stream_chacha20.c

crypto_verify_16.o: crypto_verify_16.c cryptoint/crypto_int16.h \
 crypto_verify_16.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_verify_16.c

crypto_verify_32.o: crypto_verify_32.c cryptoint/crypto_int16.h \
 crypto_verify_32.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_verify_32.c

die.o: die.c global.h log.h die.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c die.c

dropuidgid.o: dropuidgid.c e.h dropuidgid.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c dropuidgid.c

e.o: e.c e.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c e.c

env.o: env.c str.h env.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c env.c

fe25519.o: fe25519.c crypto_verify_32.h cleanup.h fe.h \
 cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h fe25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c fe25519.c

fe.o: fe.c fe.h cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c fe.c

ge25519.o: ge25519.c fe25519.h fe.h cryptoint/crypto_uint32.h \
 cryptoint/crypto_uint64.h cleanup.h ge25519.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c ge25519.c

getln.o: getln.c e.h getln.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c getln.c

global.o: global.c newenv.h channel.h cryptoint/crypto_uint32.h iptostr.h \
 porttostr.h limit.h haslimits.h packet.h buf.h cryptoint/crypto_uint8.h \
 sshcrypto.h crypto.h cryptoint/crypto_int16.h cryptoint/crypto_int32.h \
 cryptoint/crypto_int64.h cryptoint/crypto_int8.h \
 cryptoint/crypto_uint16.h cryptoint/crypto_uint64.h crypto_verify_16.h \
 crypto_verify_32.h haslibrandombytes.h randombytes.h \
 crypto_hash_sha256.h crypto_hash_sha512.h haslib25519.h \
 crypto_kem_sntrup761.h haslibntruprime.h crypto_kem_sntrup761x25519.h \
 crypto_onetimeauth_poly1305.h crypto_scalarmult_curve25519.h \
 crypto_dh_x25519.h crypto_sign_ed25519.h crypto_sort_uint32.h \
 crypto_stream_chacha20.h purge.h cleanup.h trymlock.h global.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c global.c

int16_optblocker.o: int16_optblocker.c cryptoint/crypto_int16.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c int16_optblocker.c

int32_optblocker.o: int32_optblocker.c cryptoint/crypto_int32.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c int32_optblocker.c

int64_optblocker.o: int64_optblocker.c cryptoint/crypto_int64.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c int64_optblocker.c

int8_optblocker.o: int8_optblocker.c cryptoint/crypto_int8.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c int8_optblocker.c

iptostr.o: iptostr.c byte.h iptostr.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c iptostr.c

load.o: load.c readall.h open.h e.h load.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c load.c

log.o: log.c writeall.h randommod.h purge.h cleanup.h numtostr.h e.h \
 log.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c log.c

loginshell.o: loginshell.c e.h loginshell.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c loginshell.c

logsys.o: logsys.c hasutilh.h hasutmpx.h hasutmpxupdwtmpx.h \
 hasutmpxsyslen.h hasutmpxaddrv6.h hasutmp.h hasutmpname.h hasutmppid.h \
 hasutmptime.h hasutmptv.h hasutmptype.h hasutmphost.h hasutmpuser.h \
 hasutmplogwtmp.h hasutmploginlogout.h hasutmpaddrv6.h str.h byte.h \
 logsys.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c logsys.c

main_tinysshd.o: main_tinysshd.c blocking.h ssh.h purge.h cleanup.h \

=== debian/changelog ===
tinyssh (20250201-1) unstable; urgency=medium

  * New upstream version 20250201
    - relicensed under CC0-1.0 OR 0BSD OR MIT-0 OR MIT
  * d/copyright: update license to CC0-1.0 OR 0BSD OR MIT-0 OR MIT

 -- Jan Mojžíš <janmojzis@debian.org>  Sat, 01 Feb 2025 15:47:07 +0100

=== debian/control ===
Source: tinyssh
Section: net
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 lib25519-dev,
 libntruprime-dev,
 librandombytes-dev
Maintainer: Jan Mojžíš <janmojzis@debian.org>
Homepage: https://github.com/janmojzis/tinyssh/
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/debian/tinyssh.git
Vcs-Browser: https://salsa.debian.org/debian/tinyssh
Rules-Requires-Root: no

Package: tinysshd
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 ssh-server
Architecture: any
Description: Tiny SSH server - daemon
 TinySSH is a minimalistic SSH server which implements only a subset of
 SSHv2 features.
 TinySSH supports only secure cryptography (minimum 128-bit security, protected
 against cache-timing attacks) ED25519, Curve25519(X25519), CHACHA20POLY1305.
 TinySSH implements only safe public-key authentication,
 password or hostbased authentication is not implemented.
 TinySSH has less than 100000 words of code, so it's very easily auditable.

=== debian/tests/control ===
Tests: 01makekeyprintkey
Depends:
 tinysshd

Tests: 02handshake
Depends:
 python3,
 systemd,
 systemd-sysv,
 tinysshd,
 ucspi-tcp
Restrictions: allow-stderr, needs-root, isolation-container

Tests: 03exitcodes
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 04sftp
Depends:
 openssh-client,
 openssh-sftp-server,
 tinysshd,
 ucspi-tcp

Tests: 05authorizedkeys
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 06transfer
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 07kex
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 08badauth
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 09termexec
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests: 10rekey
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp

Tests:
 valgrindtest,
Restrictions:
 allow-stderr,
 skippable,
Depends:
 build-essential,
 rsync,
 valgrind-if-available,

## tinyssh 20250501

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 CC?=cc
-CFLAGS+=-W -Wall -Os -fPIC -fwrapv -Werror=deprecated-declarations -Icryptoint
+CFLAGS+=-W -Wall -Os -fPIC -fwrapv -Icryptoint
 LDFLAGS?=
 CPPFLAGS?=
 
@@ -21,18 +21,18 @@
  crypto_dh_x25519.o crypto_hash_sha256.o crypto_hash_sha512_lib25519.o \
  crypto_hash_sha512_tinyssh.o crypto_kem_sntrup761_libntruprime.o \
  crypto_kem_sntrup761_tinyssh.o crypto_kem_sntrup761x25519.o \
- crypto_onetimeauth_poly1305.o crypto_scalarmult_curve25519.o \
- crypto_sign_ed25519_lib25519.o crypto_sign_ed25519_tinyssh.o \
- crypto_sort_uint32.o crypto_stream_chacha20.o crypto_verify_16.o \
- crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o fe.o ge25519.o \
- getln.o global.o int16_optblocker.o int32_optblocker.o int64_optblocker.o \
- int8_optblocker.o iptostr.o load.o log.o loginshell.o logsys.o main_tinysshd.o \
- main_tinysshd_makekey.o main_tinysshd_printkey.o newenv.o numtostr.o open.o \
- packet_auth.o packet.o packet_channel_open.o packet_channel_recv.o \
- packet_channel_request.o packet_channel_send.o packet_get.o packet_hello.o \
- packet_kex.o packet_kexdh.o packetparser.o packet_put.o packet_recv.o \
- packet_send.o packet_unimplemented.o porttostr.o randommod.o readall.o \
- savesync.o sc25519.o ssh.o sshcrypto.o sshcrypto_cipher.o \
+ crypto_onetimeauth_poly1305_lib1305.o crypto_onetimeauth_poly1305_tinyssh.o \
+ crypto_scalarmult_curve25519.o crypto_sign_ed25519_lib25519.o \
+ crypto_sign_ed25519_tinyssh.o crypto_sort_uint32.o crypto_stream_chacha20.o \
+ crypto_verify_16.o crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o \
+ fe.o ge25519.o getln.o global.o int16_optblocker.o int32_optblocker.o \
+ int64_optblocker.o int8_optblocker.o iptostr.o load.o log.o loginshell.o \
+ logsys.o main_tinysshd.o main_tinysshd_makekey.o main_tinysshd_printkey.o \
+ newenv.o numtostr.o open.o packet_auth.o packet.o packet_channel_open.o \
+ packet_channel_recv.o packet_channel_request.o packet_channel_send.o \
+ packet_get.o packet_hello.o packet_kex.o packet_kexdh.o packetparser.o \
+ packet_put.o packet_recv.o packet_send.o packet_unimplemented.o porttostr.o \
+ randommod.o readall.o savesync.o sc25519.o ssh.o sshcrypto.o sshcrypto_cipher.o \
  sshcrypto_cipher_chachapoly.o sshcrypto_kex.o sshcrypto_kex_curve25519.o \
  sshcrypto_kex_sntrup761x25519.o sshcrypto_key.o sshcrypto_key_ed25519.o str.o \
  stringparser.o subprocess_auth.o subprocess_sign.o trymlock.o \
@@ -44,36 +44,38 @@
  crypto_dh_x25519.o crypto_hash_sha256.o crypto_hash_sha512_lib25519.o \
  crypto_hash_sha512_tinyssh.o crypto_kem_sntrup761_libntruprime.o \
  crypto_kem_sntrup761_tinyssh.o crypto_kem_sntrup761x25519.o \
- crypto_onetimeauth_poly1305.o crypto_scalarmult_curve25519.o \
- crypto_sign_ed25519_lib25519.o crypto_sign_ed25519_tinyssh.o \
- crypto_sort_uint32.o crypto_stream_chacha20.o crypto_verify_16.o \
- crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o fe.o ge25519.o \
- getln.o global.o int16_optblocker.o int32_optblocker.o int64_optblocker.o \
- int8_optblocker.o iptostr.o load.o log.o loginshell.o logsys.o main_tinysshd.o \
- main_tinysshd_makekey.o main_tinysshd_printkey.o newenv.o numtostr.o open.o \
- packet_auth.o packet.o packet_channel_open.o packet_channel_recv.o \
- packet_channel_request.o packet_channel_send.o packet_get.o packet_hello.o \
- packet_kex.o packet_kexdh.o packetparser.o packet_put.o packet_recv.o \
- packet_send.o packet_unimplemented.o porttostr.o randombytes.o randommod.o \
- readall.o savesync.o sc25519.o ssh.o sshcrypto.o sshcrypto_cipher.o \
- sshcrypto_cipher_chachapoly.o sshcrypto_kex.o sshcrypto_kex_curve25519.o \
- sshcrypto_kex_sntrup761x25519.o sshcrypto_key.o sshcrypto_key_ed25519.o str.o \
- stringparser.o subprocess_auth.o subprocess_sign.o test-crypto.o tinysshd.o \
- _tinysshd-printkex.o _tinysshd-speed.o _tinysshd-test-hello1.o \
- _tinysshd-test-hello2.o _tinysshd-test-kex1.o _tinysshd-test-kex2.o \
- _tinysshd-unauthenticated.o trymlock.o uint16_optblocker.o uint32_optblocker.o \
- uint64_optblocker.o uint8_optblocker.o writeall.o
-
-AUTOHEADERS=haslib25519.h haslibntruprime.h haslibrandombytes.h haslibutilh.h \
- haslimits.h haslogintty.h hasmlock.h hasopenpty.h hasutilh.h hasutmpaddrv6.h \
- hasutmp.h hasutmphost.h hasutmploginlogout.h hasutmplogwtmp.h hasutmpname.h \
- hasutmppid.h hasutmptime.h hasutmptv.h hasutmptype.h hasutmpuser.h \
- hasutmpxaddrv6.h hasutmpx.h hasutmpxsyslen.h hasutmpxupdwtmpx.h hasvalgrind.h
+ crypto_onetimeauth_poly1305_lib1305.o crypto_onetimeauth_poly1305_tinyssh.o \
+ crypto_scalarmult_curve25519.o crypto_sign_ed25519_lib25519.o \
+ crypto_sign_ed25519_tinyssh.o crypto_sort_uint32.o crypto_stream_chacha20.o \
+ crypto_verify_16.o crypto_verify_32.o die.o dropuidgid.o e.o env.o fe25519.o \
+ fe.o ge25519.o getln.o global.o int16_optblocker.o int32_optblocker.o \
+ int64_optblocker.o int8_optblocker.o iptostr.o load.o log.o loginshell.o \
+ logsys.o main_tinysshd.o main_tinysshd_makekey.o main_tinysshd_printkey.o \
+ newenv.o numtostr.o open.o packet_auth.o packet.o packet_channel_open.o \
+ packet_channel_recv.o packet_channel_request.o packet_channel_send.o \
+ packet_get.o packet_hello.o packet_kex.o packet_kexdh.o packetparser.o \
+ packet_put.o packet_recv.o packet_send.o packet_unimplemented.o porttostr.o \
+ randombytes.o randommod.o readall.o savesync.o sc25519.o ssh.o sshcrypto.o \
+ sshcrypto_cipher.o sshcrypto_cipher_chachapoly.o sshcrypto_kex.o \
+ sshcrypto_kex_curve25519.o sshcrypto_kex_sntrup761x25519.o sshcrypto_key.o \
+ sshcrypto_key_ed25519.o str.o stringparser.o subprocess_auth.o \
+ subprocess_sign.o test-crypto.o tinysshd.o _tinysshd-printkex.o \
+ _tinysshd-speed.o _tinysshd-test-hello1.o _tinysshd-test-hello2.o \
+ _tinysshd-test-kex1.o _tinysshd-test-kex2.o _tinysshd-unauthenticated.o \
+ trymlock.o uint16_optblocker.o uint32_optblocker.o uint64_optblocker.o \
+ uint8_optblocker.o writeall.o
+
+AUTOHEADERS=haslib1305.h haslib25519.h haslibntruprime.h haslibrandombytes.h \
+ haslibutilh.h haslimits.h haslogintty.h hasmlock.h hasopenpty.h hasutilh.h \
+ hasutmpaddrv6.h hasutmp.h hasutmphost.h hasutmploginlogout.h hasutmplogwtmp.h \
+ hasutmpname.h hasutmppid.h hasutmptime.h hasutmptv.h hasutmptype.h \
+ hasutmpuser.h hasutmpxaddrv6.h hasutmpx.h hasutmpxsyslen.h hasutmpxupdwtmpx.h \
+ hasvalgrind.h
 
 TESTOUT=test-crypto-dh.out test-crypto-hash.out test-crypto-kem.out \
- test-crypto-sign.out test-crypto-sort.out test-crypto-verify.out \
- test-tinysshd-makekey.out test-tinysshd-printkey.out test-tinysshd.out \
- test-tinysshnoneauthd.out
+ test-crypto-onetimeauth.out test-crypto-sign.out test-crypto-sort.out \
+ test-crypto-verify.out test-tinysshd-makekey.out test-tinysshd-printkey.out \
+ test-tinysshd.out test-tinysshnoneauthd.out
 
 all: $(AUTOHEADERS) $(BINARIES) $(LINKS)
 
@@ -155,10 +157,15 @@
  crypto_kem_sntrup761.h haslibntruprime.h crypto_kem_sntrup761x25519.h
 	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_kem_sntrup761x25519.c
 
-crypto_onetimeauth_poly1305.o: crypto_onetimeauth_poly1305.c \
- cryptoint/crypto_int16.h cryptoint/crypto_uint32.h \
- cryptoint/crypto_uint64.h crypto_onetimeauth_poly1305.h
-	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_onetimeauth_poly1305.c
+crypto_onetimeauth_poly1305_lib1305.o: \
+ crypto_onetimeauth_poly1305_lib1305.c haslib1305.h
+	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_onetimeauth_poly1305_lib1305.c
+
+crypto_onetimeauth_poly1305_tinyssh.o: \
+ crypto_onetimeauth_poly1305_tinyssh.c crypto_onetimeauth_poly1305.h \
+ haslib1305.h cryptoint/crypto_int16.h cryptoint/crypto_uint32.h \
+ cryptoint/crypto_uint64.h
+	$(CC) $(CFLAGS) $(CPPFLAGS) -c crypto_onetimeauth_poly1305_tinyssh.c
 
 crypto_scalarmult_curve25519.o: crypto_scalarmult_curve25519.c cleanup.h \
  fe25519.h fe.h cryptoint/crypto_uint32.h cryptoint/crypto_uint64.h \
@@ -225,9 +232,10 @@
  crypto_verify_32.h haslibrandombytes.h randombytes.h \
  crypto_hash_sha256.h crypto_hash_sha512.h haslib25519.h \
  crypto_kem_sntrup761.h haslibntruprime.h crypto_kem_sntrup761x25519.h \
- crypto_onetimeauth_poly1305.h crypto_scalarmult_curve25519.h \
- crypto_dh_x25519.h crypto_sign_ed25519.h crypto_sort_uint32.h \
- crypto_stream_chacha20.h purge.h cleanup.h trymlock.h global.h
+ crypto_onetimeauth_poly1305.h haslib1305.h \
+ crypto_scalarmult_curve25519.h crypto_dh_x25519.h crypto_sign_ed25519.h \
+ crypto_sort_uint32.h crypto_stream_chacha20.h purge.h cleanup.h \
+ trymlock.h global.h
 	$(CC) $(CFLAGS) $(CPPFLAGS) -c global.c
 
 int16_optblocker.o: int16_optblocker.c cryptoint/crypto_int16.h
@@ -256,10 +264,3 @@
 	$(CC) $(CFLAGS) $(CPPFLAGS) -c loginshell.c
 
 logsys.o: logsys.c hasutilh.h hasutmpx.h hasutmpxupdwtmpx.h \
- hasutmpxsyslen.h hasutmpxaddrv6.h hasutmp.h hasutmpname.h hasutmppid.h \
- hasutmptime.h hasutmptv.h hasutmptype.h hasutmphost.h hasutmpuser.h \
- hasutmplogwtmp.h hasutmploginlogout.h hasutmpaddrv6.h str.h byte.h \
- logsys.h
-	$(CC) $(CFLAGS) $(CPPFLAGS) -c logsys.c
-
-main_tinysshd.o: main_tinysshd.c blocking.h ssh.h purge.h cleanup.h \

=== debian/changelog ===
tinyssh (20250501-1) unstable; urgency=medium

  * New upstream version 20250501
    - Fixed minor strict kex violation, thanks to Fabian Bäumer and Marcus
      Brinkmann for the bug report.
    - Updated cryptoint to version 20250414
    - Added support for external lib1305
  * d/copyright: update cryptoint/* license 
  * d/salsa-ci.yml add
  * d/control: B-D lib1305-dev [amd64] add

 -- Jan Mojžíš <janmojzis@debian.org>  Fri, 02 May 2025 11:19:28 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
+ lib1305-dev [amd64],
  lib25519-dev,
  libntruprime-dev,
- librandombytes-dev
+ librandombytes-dev,
 Maintainer: Jan Mojžíš <janmojzis@debian.org>
 Homepage: https://github.com/janmojzis/tinyssh/
 Standards-Version: 4.7.0
@@ -16,9 +17,9 @@
 Package: tinysshd
 Depends:
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Provides:
- ssh-server
+ ssh-server,
 Architecture: any
 Description: Tiny SSH server - daemon
  TinySSH is a minimalistic SSH server which implements only a subset of

=== debian/tests/control ===
Tests:
 01makekeyprintkey,
Depends:
 tinysshd,

Tests:
 02handshake,
Depends:
 python3,
 systemd,
 systemd-sysv,
 tinysshd,
 ucspi-tcp,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,

Tests:
 03exitcodes,
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp,

Tests:
 04sftp,
Depends:
 openssh-client,
 openssh-sftp-server,
 tinysshd,
 ucspi-tcp,

Tests:
 05authorizedkeys,
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp,

Tests:
 06transfer,
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp,

Tests:
 07kex,
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp,

Tests:
 08badauth,
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp,

Tests:
 09termexec,
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp,

Tests:
 10rekey,
Depends:
 openssh-client,
 tinysshd,
 ucspi-tcp,

Tests:
 valgrindtest,
Restrictions:
 allow-stderr,
 skippable,
Depends:
 build-essential,
 rsync,
 valgrind-if-available,

=== debian/watch ===
version=4
opts="\
pgpsigurlmangle=s/archive\/.+\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/,\
" \
https://github.com/janmojzis/@PACKAGE@/tags \
(?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## tinyssh 20260301

=== debian/changelog ===
tinyssh (20260301-1) unstable; urgency=medium

  * d/gbp.conf: upstream-branch = upstream/latest
  * d/control: update Standards-Version: 4.7.3, remove Priority: optional
  * d/control: remove Rules-Requires-Root: no
  * d/copyright: bump my copyright year

 -- Jan Mojžíš <janmojzis@debian.org>  Sun, 01 Mar 2026 07:13:44 +0000

tinyssh (20250501-2) unstable; urgency=medium

  * d/watch: rewrite to version 5, use Github uscan-template
  * d/upstream/signing-key.asc: update, add janmojzis@debian.org email
  * d/control: bump Standards-Version: 4.7.2, no changes
  * d/salsa-ci.yml: remove SALSA_CI_DISABLE_APTLY
  * d/salsa-ci.yml: add SALSA_CI_AUTOPKGTEST_ALLOWED_EXIT_STATUS
  * d/changelog: fix whitespace in 20250501-1 record

 -- Jan Mojžíš <janmojzis@debian.org>  Tue, 16 Sep 2025 08:41:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: tinyssh
 Section: net
-Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
  lib1305-dev [amd64],
@@ -9,10 +8,9 @@
  librandombytes-dev,
 Maintainer: Jan Mojžíš <janmojzis@debian.org>
 Homepage: https://github.com/janmojzis/tinyssh/
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/debian/tinyssh.git
 Vcs-Browser: https://salsa.debian.org/debian/tinyssh
-Rules-Requires-Root: no
 
 Package: tinysshd
 Depends:
